﻿using System;
using System.IO;
using System.Reflection;
using Microsoft.SharePoint;

namespace GeneralEventReceiver {
   public class ItemEventReceiver : SPItemEventReceiver {
      public override void ItemAdded(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemAdded(properties);
         } 
      }

      public override void ItemAdding(SPItemEventProperties properties) {
            Type t = ResolveType(properties.ListTitle + ".ItemEventReceiver," + properties.ListTitle);
            if (t != null) {
               SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
               spier.ItemAdding(properties);
            }
      }

      public override void ItemAttachmentAdded(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemAttachmentAdded(properties);
         }
      }

      public override void ItemAttachmentAdding(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemAttachmentAdding(properties);
         }
      }

      public override void ItemAttachmentDeleted(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemAttachmentDeleted(properties);
         }
      }

      public override void ItemAttachmentDeleting(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemAttachmentDeleting(properties);
         }
      }

      public override void ItemCheckedIn(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemCheckedIn(properties);
         }
      }

      public override void ItemCheckedOut(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemCheckedOut(properties);
         }
      }

      public override void ItemCheckingIn(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemCheckingIn(properties);
         }
      }

      public override void ItemCheckingOut(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemCheckingOut(properties);
         }
      }

      public override void ItemDeleted(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemDeleted(properties);
         }
      }

      public override void ItemDeleting(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemDeleting(properties);
         }
      }

      public override void ItemFileConverted(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemFileConverted(properties);
         }
      }

      public override void ItemFileMoved(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemFileMoved(properties);
         }
      }

      public override void ItemFileMoving(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemFileMoving(properties);
         }
      }

      public override void ContextEvent(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ContextEvent(properties);
         }
      }

      public override void ItemUncheckedOut(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemUncheckedOut(properties);
         }
      }

      public override void ItemUncheckingOut(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemUncheckingOut(properties);
         }
      }

      public override void ItemUpdated(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemUpdated(properties);
         }
      }

      public override void ItemUpdating(SPItemEventProperties properties) {
         Type t = ResolveType("ItemEventReceiver," + properties.ListTitle);
         if (t != null) {
            SPItemEventReceiver spier = (SPItemEventReceiver) Activator.CreateInstance(t);
            spier.ItemUpdating(properties);
         }
      }

      private static Type ResolveType(string typeString) {
         int commaIndex = typeString.IndexOf(",");
         string className = typeString.Substring(0, commaIndex).Trim();
         string assemblyName = typeString.Substring(commaIndex + 1).Trim();
         Assembly assembly = null;
         try {
            byte[] b = File.ReadAllBytes("C:\\EventHandler\\"+assemblyName+".dll");
            assembly = Assembly.Load(b);
         } catch {
            throw new ArgumentException("Can't load assembly " + assemblyName);
         }
         return assembly.GetType(className, false, false);
      }
   }
}